import { webpack5 } from 'next/dist/compiled/webpack/webpack';
import type { WasmBinding } from '../loaders/next-middleware-wasm-loader';
export declare const ssrEntries: Map<string, {
    requireFlightManifest: boolean;
}>;
export interface MiddlewareManifest {
    version: 1;
    sortedMiddleware: string[];
    clientInfo: [location: string, isSSR: boolean][];
    middleware: {
        [page: string]: {
            env: string[];
            files: string[];
            name: string;
            page: string;
            regexp: string;
            wasm?: WasmBinding[];
        };
    };
}
interface PerRoute {
    envPerRoute: Map<string, string[]>;
    wasmPerRoute: Map<string, WasmBinding[]>;
}
export default class MiddlewarePlugin {
    dev: boolean;
    constructor({ dev }: {
        dev: boolean;
    });
    createAssets(compilation: webpack5.Compilation, assets: any, { envPerRoute, wasmPerRoute }: PerRoute): void;
    apply(compiler: webpack5.Compiler): void;
}
export {};
